// reverse Polish calculator

const int MAXOP=50000; /* max size of operand or operator */
const int NUMBER='0'; /* signal that a number was found */
const int MAXCOMMAND=4096; /* maximum number of operands etc to calculate */
const int MAXSTRING=4096;
const int NUMLIMIT=32767; /* maximum limit in input */
const int MAXVAL=500; /* maximum depth of val stack */
const int MAXFUNCTIONMAME=25; // max chars in function names
const int MAXFUNCTIONPARAMETERS=5; // max parameters in functions, separated with comma
const int SPACE=32;

enum { BACKWARDS = 0, FORWARD };

int parenthesesincluderforpolishreversecalculator(char formula[]);
int reversepolishcalculatorequalizer(char formula[]);
int isformulainpolishcalculatorsyntax(char formula[]);
double reversepolishcalculator(char formula[]);
int getop(char s[], char formula[], int minusflag=0);
void push(double f);
double pop(void);
int findsimple(char text[], char token[]);
char *ctos(int t);
int mod (double a, double b);
int isdecimalseparator(char t);
char *dtoa(long double val);
int isdigit2(char t);
int previousnextarraychar(char *s, int pos, int direction);
extern void removedoublespaces(char text[]);

// char formula[MAXCOMMAND];
int pos;
int sp = 0; /* next free stack position */
double val[MAXVAL]; /* value stack */
int isfunction=0; // flag to take functions symbols into account
int openparentheses; // parentheses open for parser

// reverse Polish calculator start

// reverse polish calculator
double reversepolishcalculator(char formula[])
{
int type;
double op2,op3;
char s[MAXOP];

    pos=0;
    while ((type = getop(s, formula, 1)) != EOF) {
     switch (type) {
      case NUMBER:
       push(atof(s));
      break;
      case '+':       
       push(pop() + pop());
      break;
      case '*':
       push(pop() * pop());
      break;
      case '^':
       push (pow(pop(),pop()));
      break;
      case '-':
       op2 = pop();
       push(pop() - op2);
      break;
      case '/':
       op2 = pop();
       if (op2)
        push(pop() / op2);
      break;
      case '%':
       int iop4, iop5;
       iop4=(int) pop();
       iop5=(int) pop();
       if (iop4) {
        op3=iop5 % iop4;;
       push(op3); }
       else
        push(0);
      break;
      case '&':
       int op5;
       pop();
       op2=pop();
       if (op2)
        push((op5=rand() % (int) op2));
      break;
      case '@':
       int op4;
       op2=pop() * pop();
       op3=mod(op2,10);
       op4= (op2>9) ? (op2/10) + op3 : op2;
       op2=op4;
       push(op2);
      break;
      // new functions
      case '!':
       pop();
       push(abs((pop())));
      break;
      case '[':
       pop();
       push(sin(pop()));
      break;
      case ']':
       pop();
       push(cos(pop()));
      break;
      case ';':
       pop();
       push(tan(pop()));
      break;
      case '|':
       pop();
       op2=pop();
       if (op2)
        push(1/(tan(op2)));
      break;
      case '?':
       pop();
       push(sqrt(pop()));
      break;
      case ':':
       pop();
       push(log(pop()));
      break;
      case '=':
       op2=pop();
       op3=pop();
       if ( op2 == op3 )
        push(1);
       else
        push(0);
      break;
      case '>':
       op2=pop();
       op3=pop();
       if ( op2 < op3 )
        push(1);
       else
        push(0);
      break;
      case '}':
       op2=pop();
       op3=pop();
       if ( op2 <= op3 )
        push(1);
       else
        push(0);
      break;
      case '<':
       op2=pop();
       op3=pop();
       if ( op2 > op3 )
        push(1);
       else
        push(0);
      break;
      case '{':
       op2=pop();
       op3=pop();
       if ( op2 >= op3 )
        push(1);
       else
        push(0);
      break;
      case '\0':
       return pop();
      default:
      break;
     }
    }
   
 return 0;
}

/* getop: get next character or numeric operand */
int getop(char s[], char formula[], int minusflag) // -1 skip - for negative, 0 nothing, 1 turn _ to c and skip
{
int i, c, tpos;

  if (pos>(int)strlen(formula))
   return EOF;
  while ( (s[0] = c = formula[pos++]) == ' ' || c == '\t' );
  s[1] = '\0';
  
  /* trick getop for <= >= */
  if ( c == '<' )
   if ( formula[pos] == '=' )
    c=formula[pos++]='{';
  if ( c == '>' )
   if ( formula[pos] == '=' )
    c=formula[pos++]='}';

  if ( c == '_' && isdigit2(formula[pos]) ) {
   c=formula[pos]; /* turn c to digit so number part will be collected */
   if ( minusflag == 1)
    s[0]='-';
  }
  if ( minusflag == -1 && (c == '-' || c=='_') && isdigit2(formula[pos]) )
   c=formula[pos]; /* turn c to digit so number part will be collected */
   
  if ( !isdigit2(c) && !isdecimalseparator(c) )
   return c; /* not a number */

  i = 0;
  if ( isdigit2(c) ) /* collect integer part */
   while (isdigit2(s[++i] = c = formula[pos++]));
   if (isdecimalseparator(c)) { /* collect fraction part */
    s[i]='.';
    while (isdigit2(s[++i] = c = formula[pos++]));
   }
  s[i] = '\0';

 return NUMBER;
}

/* push: push f onto value stack */
void push(double f)
{
  if (sp < MAXVAL)
   val[sp++] = f;
}

/* pop: pop and return top value from stack */
double pop(void)
{
  if (sp > 0)
   return val[--sp];
  else
  return 0.0;
}

// parentheses clearance
int parenthesesincluderforpolishreversecalculator(char formula[])
{
  char tformula[MAXCOMMAND], tendformula[MAXCOMMAND], ts[50];
  int tformula_pos=0, i, i1, n, tpos[2], operation=1;
  double f;
  
   // check for equal number of parentheses
   openparentheses=0;
   for (i=0;i<strlen(formula);i++) {
    if (formula[i]=='(')
     ++openparentheses;
    if (formula[i]==')')
   --openparentheses; }
   if (openparentheses) // not all parentheses closed
    return openparentheses;
   strcpy(tformula, formula);
   while (operation) {
    operation=0;
    for (i=0;i<strlen(tformula);i++) {
     if (tformula[i]==')') {
      tpos[1]=i; tpos[0]=i;
      while (tformula[tpos[0]]!='(')
       --tpos[0];
      if (tpos[0]<0)
       return 999;
      operation=1;
      // copy parenthesis content into formula
      for (n=0;n<tpos[1]-tpos[0]-1;n++)
       formula[n]=tformula[tpos[0]+n+1];
      formula[n]='\0';
      // run reversepolishcalculator routines
      reversepolishcalculatorequalizer(formula);
      f=reversepolishcalculator(formula);
      // fill tformula parenthesis content with spaces
      for (n=tpos[0];n<tpos[1]+1;n++)
       tformula[n]=' ';
      // copy rest of of tformula to tendformula
      i1=0;
      for (n=tpos[1];n<strlen(tformula);n++)
       tendformula[i1++]=tformula[n];
      tendformula[i1]='\0';
      // append f to end of tformula
      strcpy(ts, dtoa(f));
      for (n=0;n<strlen(ts);n++)
       tformula[tpos[0]+n+1]=ts[n];
      // append tendformula to formula
      for (i1=0;i1<strlen(tendformula);i1++)
       tformula[tpos[0]+n+i1]=tendformula[i1];
      tformula[tpos[0]+n+i1]='\0';
    break; } } }
   strcpy(formula, tformula);
   
  return 0;
}

// equalize text for reversepolishcalculator use
int reversepolishcalculatorequalizer(char formula[])
{
  char transformedtext[MAXCOMMAND], ttransformedtext[MAXCOMMAND];
  int type, i, n, i1, operation=1, numbers=0;
  double f;
  char tc, s[MAXOP];
   
   removedoublespaces(formula);
   // lets see if formula has any digits
   n=0;
   for (i=0;i<strlen(formula);i++)
    if (isdigit2(formula[i]))
     ++n;
   if (!n) // no numbers, return 0 (this was done done for mixed type formula fields)
    return 0;
  
   // replace negative number signs
   if ( isformulainpolishcalculatorsyntax(formula) == 1 )
    for (i=0;i<(int)strlen(formula);i++)
     if ( formula[i] == '-' && isdigit2(formula[i+1]) )
      formula[i]='_';
   if ( isformulainpolishcalculatorsyntax(formula) == 0 ) 
    for (i=0;i<(int)strlen(formula);i++)
     if ( formula[i] == '-' && isdigit2(formula[i+1]) )
      if ( !isdigit2((i1=previousnextarraychar(formula, i-1, BACKWARDS))) )
       formula[i]='_';
     
   // repair space positions where necessary 
   for (i=n=0;i<(int)strlen(formula);i++) {
    transformedtext[n]=formula[i];

    // add spaces, where necessary
    if ( isdigit2(transformedtext[n]) && !isdigit2(formula[i+1]) && !isdecimalseparator(formula[i+1]) )
     transformedtext[++n]=' ';
    if ( !isdigit2(transformedtext[n]) && isdigit2(formula[i+1]) && !isdecimalseparator(transformedtext[n]) && transformedtext[n] != '_' && !isspace(transformedtext[n]) )
     transformedtext[++n]=' '; 
     ++n;
    
   }
   transformedtext[n]='\0';
   strcpy(formula, transformedtext);

   // reverse Reverse Polish syntax
   if ( isformulainpolishcalculatorsyntax(formula) == 0 ) {
    type=getop(s, formula); // read first number
    strcpy(transformedtext, s);
    while ( (type = getop(s, formula)) != EOF ) {
     if ( type == NUMBER ) {
      strcat(transformedtext, s);
      ++numbers;
     }
     strcat(transformedtext, " ");
     if ( type != NUMBER )
      tc=type;
     if ( numbers ) {
      strcat(transformedtext, ctos(tc));
      numbers=0;
     }
    }
    strcpy(formula, transformedtext);
   }
    
 return 1;
}

// is string in polish calculator syntax ?
int isformulainpolishcalculatorsyntax(char formula[])
{
  int i, type=0;
  char s[MAXOP];
  pos=0;
  
   if ( (getop(s, formula, -1)) == NUMBER && (getop(s, formula, -1)) == NUMBER && !isdigit2((i=getop(s, formula))) )
    type=1;
   if ( i == EOF )
    type = 0;
   pos=0;
  
 return type;
}

// find command in text
int findsimple(char text[MAXCOMMAND], char token[MAXCOMMAND])
{ 
  int i, n, hit=0;
  char ttoken[MAXCOMMAND];
  
   for (i=0;i<(int)strlen(text);i++, hit=0) {
    if (text[i]==token[0]) {
     hit=i+1;
     for (n=0;n<(int)strlen(token);n++)
      ttoken[n]=text[i+n];
     ttoken[n]='\0';
     if (!strcmp(ttoken, token)) 
      break;
    }
   }
   
 return hit;
}

// char to null terminated string
char *ctos(int t)
{
  static char s[3];
  
   s[0]=(char) t;
   s[1]='\0';
   
 return s;
}

int mod(double a, double b)
{
 int tmp=a/b;
 
  return a-(b*tmp);
}

// isdecimalseparator
int isdecimalseparator(char t)
{
  if (t==',' || t=='.')
   return 1;
  
 return 0;
}

// dtoa to string
char *dtoa(long double val)
{
  static char result[MAXOP];
  int i;
  std::string str = std::to_string(val);
  
  for (i=0;i<str.size();i++)
   result[i]=str[i];
  result[i]='\0';
  
 return &result[0];
}

// is char digit
int isdigit2(char t)
{
  if ( t >= 48 && t <= 57 )
   return 1;

 return 0;
}

// previous or next char in array
int previousnextarraychar(char *s, int pos, int direction)
{
  int t=pos;
 
   switch ( direction ) {
    case BACKWARDS:
     while ( t > - 1 && s[t] == SPACE )
      --t;
     break;
     case FORWARD:
      while ( t < (int)strlen(s) && s[t] == SPACE )
       ++t;   
     break;
   }
  
 return ( t == -1 || t == (int)strlen(s) ) ? 0 : s[t];
}

// end of Polish Calculator
